Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# GraphicsPipe Class Reference

An object to create GraphicsOutputs that share a particular 3-D API. More...

Inheritance diagram for GraphicsPipe:

List of all members.

## Public Types
enum | BufferCreationFlags { BFRefuseParasite = 1, BFRequireParasite = 2, BFRefuseWindow = 4, BFRequireWindow = 8, BFRequireCallbackWindow = 16, BFCanBindColor = 64, BFCanBindEvery = 128, BFResizeable = 256, BFSizeTrackHost = 512, BFRttCumulative = 1024, BFFbPropsOptional = 2048, BFSizeSquare = 4096, BFSizePower2 = 8192 }
enum | OutputTypes { OTWindow = 1, OTFullscreenWindow = 2, OTBuffer = 4, OTTextureBuffer = 8 }
## Public Member Functions
int | getDisplayHeight ()
| Returns the height of the entire display, if it is known.
DisplayInformation | getDisplayInformation ()
| Gets the pipe's DisplayInformation.
int | getDisplayWidth ()
| Returns the width of the entire display, if it is known.
string | getInterfaceName ()
int | getSupportedTypes ()
| Returns the mask of bits that represents the kinds of GraphicsOutput objects this pipe might be able to successfully create.
bool | isValid ()
| Returns false if this pipe is known to be invalid, meaning that an attempt to create a GraphicsWindow with the pipe will certainly fail.
| lookupCpuData ()
| Looks up the detailed CPU information and stores it in _display_information, if supported by the OS.
bool | supportsType (int flags)
| A convenience function to ask if a particular type or types of GraphicsObjects are supported.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

An object to create GraphicsOutputs that share a particular 3-D API.

Normally, there will only be one GraphicsPipe in an application, although it is possible to have multiple of these at once if there are multiple different API's available in the same machine.

Often, the GraphicsPipe corresponds to a physical output device, hence the term "pipe", but this is not necessarily the case.

The GraphicsPipe is used by the GraphicsEngine object to create and destroy windows; it keeps ownership of the windows it creates.

M. Asad added new/interim functionality where GraphicsPipe now contains a device interface to directx/opengl which will be used to handle multiple windows from same device.

## Member Enumeration Documentation

enum BufferCreationFlags

Enumerator:

  BFRefuseParasite |
  BFRequireParasite |
  BFRefuseWindow |
  BFRequireWindow |
  BFRequireCallbackWindow |
  BFCanBindColor |
  BFCanBindEvery |
  BFResizeable |
  BFSizeTrackHost |
  BFRttCumulative |
  BFFbPropsOptional |
  BFSizeSquare |
  BFSizePower2 |

enum OutputTypes

Enumerator:

  OTWindow |
  OTFullscreenWindow |
  OTBuffer |
  OTTextureBuffer |

## Member Function Documentation

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TypedReferenceCount.

int getDisplayHeight | ( |  | ) |

Returns the height of the entire display, if it is known.

This may return 0. See the caveats for get_display_width().

DisplayInformation getDisplayInformation | ( |  | ) |

Gets the pipe's DisplayInformation.

int getDisplayWidth | ( |  | ) |

Returns the width of the entire display, if it is known.

This may return 0. This is not a guarantee that windows (particularly fullscreen windows) may not be created larger than this width, but it is intended to provide a hint to the application.

string getInterfaceName | ( |  | ) |

int getSupportedTypes | ( |  | ) |

Returns the mask of bits that represents the kinds of GraphicsOutput objects this pipe might be able to successfully create.

The return value is the union of bits in GraphicsPipe.OutputTypes that represents the set of GraphicsOutput types.

A 1 bit in a particular position is not a guarantee of success, but a 0 bit is a guarantee of failure.

bool isValid | ( |  | ) |

Returns false if this pipe is known to be invalid, meaning that an attempt to create a GraphicsWindow with the pipe will certainly fail.

Returns true if the pipe is probably valid (is this case, an attempt to create a GraphicsWindow should succeed, but might still fail).

Use the GraphicsEngine class to create a GraphicsWindow on a particular pipe.

lookupCpuData | ( |  | ) |

Looks up the detailed CPU information and stores it in _display_information, if supported by the OS.

This may take a second or two.

bool supportsType | ( | int | flags | ) |

A convenience function to ask if a particular type or types of GraphicsObjects are supported.

The parameter is a union of one or more bits defined in GrpahicsPipe.OutputTypes.

Returns true if all of the requested types are listed in the supported_types mask, false if any one of them is not. This is not a guarantee that the indicated output type will successfully be created when it is attempted.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties